
f = open('flat_ccw.txt', 'r')

f.readline() # ignore header

def twocomplement(val):
    if val & 0x8000:
        val ^= 0xFFFF
        val += 1
        val *= -1
    return val

class i2cpacket(object):
    
    def __init__(self):
        self.starttime = None
        self.packet = None
        self.i2caddr = None
        self.regaddr = None
        self.write = None
        self.data = []

    def pushentry(self, time, packet, i2caddr, data, rw, acknak):
        if self.starttime == None:
            self.starttime = time
            self.packet = packet
            self.i2caddr = i2caddr
            self.data.append(data)
            self.write = rw == "Write"
            #ignore acknak
            return True
        else:
            if self.packet == packet and self.i2caddr == i2caddr:
                self.data.append(data)
                return True
            else:
                return False
    
    def to_array(self):
        datastr = ''.join('{:02X}'.format(c) for c in self.data)
        val = 0
        
        if len(self.data) == 2:
            for v in self.data:
                val <<= 8
                val |= v
        val = twocomplement(val)
        #datastr = ' '.join(self.data)
        return '\t'.join(str(c) for c in [self.starttime, self.packet, self.i2caddr, self.regaddr, self.write, datastr, val])

packets = []
lastpacket = i2cpacket()
packets.append(lastpacket)

for line in f:
    line = line.strip()
    if line == "":
        break
    time, packet, i2caddr, data, rw, acknak = line.split(",")

    if lastpacket.pushentry(time, packet, i2caddr, int(data, 16), rw, acknak) == False:
        lastpacket = i2cpacket()
        lastpacket.pushentry(time, packet, i2caddr, int(data, 16), rw, acknak)
        packets.append(lastpacket)

regaddr = 0
regs = []
for p in packets:
    if p.write == True:
        regaddr = p.data[0]
        p.regaddr = regaddr
        regaddr += len(p.data) - 1
        if len(p.data) > 1:
            print(p.to_array())
    else:
        p.regaddr = regaddr
        print(p.to_array())
